Merge "Fixes FDIO kernel settings" into stable/colorado
[apex.git] / lib / overcloud-deploy-functions.sh
index 41aaf26..53c7eef 100755 (executable)
@@ -11,6 +11,9 @@
 ##preping it for deployment and launch the deploy
 ##params: none
 function overcloud_deploy {
+  local num_compute_nodes
+  local num_control_nodes
+
   if [[ "${#deploy_options_array[@]}" -eq 0 || "${deploy_options_array['sdn_controller']}" == 'opendaylight' ]]; then
     if [ "${deploy_options_array['sdn_l3']}" == 'True' ]; then
       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight_l3.yaml"
@@ -20,6 +23,8 @@ function overcloud_deploy {
       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight_sdnvpn.yaml"
     elif [ "${deploy_options_array['vpp']}" == 'True' ]; then
       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight_fdio.yaml"
+    elif [ "${deploy_options_array['vpn']}" == 'true' ]; then
+      DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight_sdnvpn.yaml"
     else
       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight.yaml"
     fi
@@ -69,7 +74,7 @@ function overcloud_deploy {
   scp ${SSH_OPTIONS[@]} $RESOURCES/overcloud-full-${SDN_IMAGE}.qcow2 "stack@$UNDERCLOUD":overcloud-full.qcow2
 
   # Install ovs-dpdk inside the overcloud image if it is enabled.
-  if [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
+  if [[ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' || "${deploy_options_array['dataplane']}" == 'fdio' ]]; then
     # install dpdk packages before ovs
     echo -e "${blue}INFO: Enabling kernel modules for dpdk inside overcloud image${reset}"
 
@@ -88,14 +93,34 @@ EOF
                                                --upload uio_pci_generic.modules:/etc/sysconfig/modules/ \
                                                --run-command "chmod 0755 /etc/sysconfig/modules/vfio_pci.modules" \
                                                --run-command "chmod 0755 /etc/sysconfig/modules/uio_pci_generic.modules" \
-                                               --run-command "yum install -y /root/dpdk_rpms/*" \
                                                -a overcloud-full.qcow2
+
+      if [ "${deploy_options_array['dataplane']}" == 'fdio' ]; then
+        sudo sed -i '/FdioEnabled:/c\  FdioEnabled: true' /usr/share/openstack-tripleo-heat-templates/environments/numa.yaml
+        LIBGUESTFS_BACKEND=direct virt-customize --run-command "cp -f /root/fdio_neutron_l3/namespaces.py /usr/lib/python2.7/site-packages/neutron/agent/l3/" \
+                                                 --run-command "cp -f /root/fdio_neutron_l3/router_info.py /usr/lib/python2.7/site-packages/neutron/agent/l3/" \
+                                                 -a overcloud-full.qcow2
+        if [ "${deploy_options_array['sdn_controller']}" == 'opendaylight' ]; then
+          LIBGUESTFS_BACKEND=direct virt-customize --run-command "cd /root/ && tar zxvf networking-odl.tar.gz" \
+                                                   --run-command "cd /root/networking-odl && git init && pip install -r requirements.txt" \
+                                                   --run-command "cd /root/networking-odl && python setup.py build && python setup.py install" \
+                                                   -a overcloud-full.qcow2
+        fi
+      else
+        LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum install -y /root/dpdk_rpms/*" \
+                                                 -a overcloud-full.qcow2
+      fi
 EOI
+
   elif [ "${deploy_options_array['dataplane']}" != 'ovs' ]; then
     echo "${red}${deploy_options_array['dataplane']} not supported${reset}"
     exit 1
   fi
 
+  if [ "$debug" == 'TRUE' ]; then
+    ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "LIBGUESTFS_BACKEND=direct virt-customize -a overcloud-full.qcow2 --root-password password:opnfvapex"
+  fi
+
   # Set ODL version accordingly
   if [[ "${deploy_options_array['sdn_controller']}" == 'opendaylight' && "${deploy_options_array['odl_version']}" == 'boron' ]]; then
     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
@@ -115,7 +140,7 @@ EOI
     # Push performance options to subscript to modify per-role images as needed
     for option in "${performance_options[@]}" ; do
       echo -e "${blue}Setting performance option $option${reset}"
-      ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "bash build_perf_image.sh $option"
+      ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "dataplane=${deploy_options_array['dataplane']} bash build_perf_image.sh $option"
     done
 
     # Build IPA kernel option ramdisks
@@ -146,6 +171,12 @@ find . | cpio -o -H newc | gzip > /home/stack/Controller-ironic-python-agent.ini
 chown stack /home/stack/Controller-ironic-python-agent.initramfs
 popd
 /bin/rm -rf ipa/
+EOI
+
+    # set NIC heat params and resource registry
+    ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
+sed -i '/TenantNIC:/c\  TenantNIC: '${private_network_compute_interface} opnfv-environment.yaml
+sed -i '/PublicNIC:/c\  PublicNIC: '${public_network_compute_interface} opnfv-environment.yaml
 EOI
 
     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/numa.yaml"
@@ -154,24 +185,33 @@ EOI
   # make sure ceph is installed
   DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/storage-environment.yaml"
 
-  # scale compute nodes according to inventory
-  total_nodes=$(ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "cat /home/stack/instackenv.json | grep -c memory")
+  # get number of nodes available in inventory
+  num_control_nodes=$(ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "grep -c profile:control /home/stack/instackenv.json")
+  num_compute_nodes=$(ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "grep -c profile:compute /home/stack/instackenv.json")
 
   # check if HA is enabled
   if [[ "$ha_enabled" == "True" ]]; then
-     DEPLOY_OPTIONS+=" --control-scale 3"
-     compute_nodes=$((total_nodes - 3))
+    if [ "$num_control_nodes" -lt 3 ]; then
+      echo -e "${red}ERROR: Number of control nodes in inventory is less than 3 and HA is enabled: ${num_control_nodes}. Check your inventory file.${reset}"
+      exit 1
+    else
+     DEPLOY_OPTIONS+=" --control-scale ${num_control_nodes}"
      DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/puppet-pacemaker.yaml"
+     echo -e "${blue}INFO: Number of control nodes set for deployment: ${num_control_nodes}${reset}"
+    fi
   else
-     compute_nodes=$((total_nodes - 1))
+    if [ "$num_control_nodes" -lt 1 ]; then
+      echo -e "${red}ERROR: Number of control nodes in inventory is less than 1: ${num_control_nodes}. Check your inventory file.${reset}"
+      exit 1
+    fi
   fi
 
-  if [ "$compute_nodes" -le 0 ]; then
-    echo -e "${red}ERROR: Invalid number of compute nodes: ${compute_nodes}. Check your inventory file.${reset}"
+  if [ "$num_compute_nodes" -le 0 ]; then
+    echo -e "${red}ERROR: Invalid number of compute nodes: ${num_compute_nodes}. Check your inventory file.${reset}"
     exit 1
   else
-    echo -e "${blue}INFO: Number of compute nodes set for deployment: ${compute_nodes}${reset}"
-    DEPLOY_OPTIONS+=" --compute-scale ${compute_nodes}"
+    echo -e "${blue}INFO: Number of compute nodes set for deployment: ${num_compute_nodes}${reset}"
+    DEPLOY_OPTIONS+=" --compute-scale ${num_compute_nodes}"
   fi
 
   if [[ "$net_isolation_enabled" == "TRUE" ]]; then
@@ -183,9 +223,8 @@ EOI
      DEPLOY_OPTIONS+=" --ntp-server $ntp_server"
   fi
 
-  if [[ ! "$virtual" == "TRUE" ]]; then
-     DEPLOY_OPTIONS+=" --control-flavor control --compute-flavor compute"
-  else
+  DEPLOY_OPTIONS+=" --control-flavor control --compute-flavor compute"
+  if [[ "$virtual" == "TRUE" ]]; then
      DEPLOY_OPTIONS+=" -e virtual-environment.yaml"
   fi
 
@@ -194,12 +233,24 @@ EOI
   echo -e "${blue}INFO: Deploy options set:\n${DEPLOY_OPTIONS}${reset}"
 
   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
-if [ "$debug" == 'TRUE' ]; then
-    LIBGUESTFS_BACKEND=direct virt-customize -a overcloud-full.qcow2 --root-password password:opnfvapex
+if [ "${deploy_options_array['tacker']}" == 'False' ]; then
+    sed -i '/EnableTacker:/c\  EnableTacker: false' opnfv-environment.yaml
 fi
 
+# Create a key for use by nova for live migration
+echo "Creating nova SSH key for nova resize support"
+ssh-keygen -f nova_id_rsa -b 1024 -P ""
+public_key=\'\$(cat nova_id_rsa.pub | cut -d ' ' -f 2)\'
+sed -i "s#replace_public_key:#key: \$public_key#g" opnfv-environment.yaml
+python -c 'open("opnfv-environment-new.yaml", "w").write((open("opnfv-environment.yaml").read().replace("replace_private_key:", "key: \"" + "".join(open("nova_id_rsa").readlines()).replace("\\n","\\\n") + "\"")))'
+mv -f opnfv-environment-new.yaml opnfv-environment.yaml
+
 source stackrc
 set -o errexit
+# Workaround for APEX-207 where sometimes swift proxy is down
+if ! sudo systemctl status openstack-swift-proxy > /dev/null; then
+  sudo systemctl restart openstack-swift-proxy
+fi
 echo "Uploading overcloud glance images"
 openstack overcloud image upload